$global:TOKENSTATUS = $null
$global:TOKENVAL = $null
$global:TOKENEXP = $null
$global:LOGSLOCATION = $null
$global:PROCESSEDLOCATION = $null
$global:UserName = $null
$global:userDesc = $null
$global:TransDay = $null
$global:TransDate = $null
$global:TransYear = $null
$global:TransTime = $null
$global:Time = $null
$global:TransDirectoryName = $null
$global:FileName = $null
$global:ServerName = $null


. (Join-Path $PSScriptRoot variables.ps1)
. (Join-Path $PSScriptRoot functions.ps1)


#################################
# Get token #

#gettoken

#Debugging Token Values
#write-host $TOKENSTATUS
#write-host $TOKENVAL
#write-host $TOKENEXP

Write-Host "Checking Token Expiration..."

#################################
# Create Headers #

$BASICAUTH = [Convert]::ToBase64String([Text.Encoding]::ASCII.GetBytes(("{0}:{1}" -f "$($USER)/$($DEPT)","$($PWD)")))
$HEADERS = @{
#	"token"="$($TOKENVAL)"
	"Authorization"="Basic $BASICAUTH"
	"Content-Type"="application/json"
}
#Write-Host "Headers: "$HEADERS


##################################
# Begin FOREACH loop calling API for each CSV #

#Write-Host "Getting parameters from "$CSVFILE
$LOGS = Get-ChildItem -Path $LOGSLOCATION -Force -Filter "*.csv"

#Write-Host "Logslocation: "$LOGSLOCATION
#Write-Host "Logslocation: "$LOGS

foreach ($LOG in $LOGS)
	{
#$LoginID,$FullName,$Date,$Time,$LocalHomeDirectory,$LocalFileName,$server
$CSVFILE = Import-CSV $LOG.FullName -header UserName, userDesc, TransDay, TransDate, TransYear, TransTime, TransDirectoryName, FileName, ServerName
Write-Host "CSVFILE: "$CSVFILE


##################################
# Create body and pass the CSV parameters to it for converting to JSON format. #

ForEach ($COLUMN in $CSVFILE){
        $global:UserName=$($CSVFILE.UserName)
		#Write-Host "UserName_1: "$CSVFILE.UserName
        $global:userDesc=$($CSVFILE.userDesc)
        $global:TransDay=$($CSVFILE.TransDay)
        $global:TransDate=$($CSVFILE.TransDate)
        $global:TransYear=$($CSVFILE.TransYear)
        $global:TransTime=$($CSVFILE.TransTime)
        $global:TransDirectoryName=$($CSVFILE.TransDirectoryName)
        $global:FileName=$($CSVFILE.FileName)
        $global:ServerName=$($CSVFILE.ServerName)
        }

##################################		
# Convert date format #

$TRUNKDATE = $TransDate,$TransYear -join" "
$TRUNKDATE = Parse-CustomDate -DateString $TRUNKDATE
$TRUNKDATE = $TRUNKDATE.ToString('yyyyMMdd')
#Write-Host "Trunkdate: $TRUNKDATE"

##################################
# Convert time format#

#Write-Host "CSV.TransTime: $($CSVFILE.TransTime)"
#Write-Host "Pre-change TransTime: $TransTime"
$TransTime = Parse-CustomTime -TimeString "$($CSVFILE.TransTime)"
#Write-Host "TransTime: $TransTime"
$Time = $TransTime.ToString('HHmmss')
#Write-Host "Time: $TIME"

##################################		
# Debugging the parameter variables #

#Write-Host "UserName: "$UserName
#Write-Host "userDesc: "$userDesc
#Write-Host "TransDate: "$TransDate
#Write-Host "TransYear: "$TransYear
#Write-Host "Time: "$Time
#Write-Host "TransDirectoryName: "$TransDirectoryName
#Write-Host "FileName: "$FileName
#Write-Host "ServerName: "$ServerName

##################################
# Convert body to JSON format
$JSON = ConvertTo-Json @{
		object_name = "$CALLEDOBJECT";
		inputs = @{
			execution_option = "execute";
			"var1" = $UserName;
			"var2" = $userDesc;
#			"var3" = "$TransDay";
			"var4" = $TRUNKDATE;
			"var5" = $($LOG.FullName);
			"var6" = $Time;
			"var7" = $TransDirectoryName;
			"var8" = $FileName;
			"var9" = $ServerName;
		};		
	}

##################################
# API Authentication call #

#$APIAUTH = Invoke-RestMethod -Uri $LOGINURL -Method GET -Headers $HEADERS

#Write-Host "Sending auth call: $($APIAUTH)"

#$APIAUTH

##################################
# Execute the API call with headers and the JSON #

Write-Host "Sending run call: Invoke-RestMethod -Uri $RUNURL -Method POST -Body $JSON -Headers $HEADERS"



$APIRUN = Invoke-RestMethod -Uri $RUNURL -Method POST -Body $JSON -Headers $HEADERS



$APIRUN

##################################
# End foreach loop
}


##################################
#logout with token #

#Write-Host "LogoutURL: $LOGOUTURL"

#$APILOGOUT = Invoke-RestMethod -Uri "$LOGOUTURL" -Method GET -Headers $HEADERS

#Write-Host "Sending logout call: $($APILOGOUT)"

#$APILOGOUT

